#include<mpi.h>
#include<stdlib.h>
#include<stdio.h>

int main(int argc,char **argv)
{
   int np, me, flag, ntest, i, nsend, nrecv, startsend, startrecv;
   int size = 10000;
   MPI_Request req;
   double vec[size];

   MPI_Init(&argc,&argv);
   MPI_Comm_size(MPI_COMM_WORLD,&np);
   MPI_Comm_rank(MPI_COMM_WORLD,&me);

   for (i = 0 ; i < 10; i++)
   {
      vec[i] = 0.; 
   }

   if (me == 1)
   { 
 
// Initialize a large array to delay the sending 
      for (i = 0 ; i < size; i++)
      {
         vec[i] = i;
      }
      printf("\n %d >> initial:    vec=",me);
      for (i = 0 ; i < 10; i++) printf("%3.0f",vec[i]); printf("\n");
      startsend = 4; nsend = 3;
      MPI_Send( &vec[startsend], nsend, MPI_DOUBLE, 0, 11, MPI_COMM_WORLD);
   }

   if (me == 0)
   {  startrecv = 1; nrecv = 3;
      printf("\n %d >> initial:    vec=",me);
      for (i = 0 ; i < 10; i++) printf("%3.0f",vec[i]); printf("\n");
      MPI_Irecv(&vec[startrecv], nrecv, MPI_DOUBLE, MPI_ANY_SOURCE, MPI_ANY_TAG, 
               MPI_COMM_WORLD, &req);
      flag = 0; ntest=0;
      while (flag == 0)
      {
         MPI_Test( &req, &flag, MPI_STATUS_IGNORE );
         ntest = ntest + 1;
//         printf("\n flag = %d ",flag);
      }
      printf("\n %d >> after %d tests",me, ntest);
      printf("\n %d >> after recv: vec=",me);
      for (i = 0 ; i < 10; i++) printf("%3.0f",vec[i]); printf("\n");
   }
   MPI_Finalize();
   return 0;
}
