#include <mpi.h>
#include<math.h>
#include<stdio.h>

double f(double x);
double numint(double lo, double hi, int n, double res);
  int main(int argc,char **argv)
{ 
  double pia, hi, lo, delt, width, t, t1, r;
  double piexact = 3.14159265358979323846264338327950288419; 
  int i, n, nl, nin;
  MPI_Init(&argc,&argv);
/*  input of number of intervals n*/
  printf("\n  number of strips ?  \n");
  scanf("%d",&n);
 printf("\n  number of intervalls ?  \n");
  scanf("%d",&nin);

  printf("\n calculation of pi using numerical integration of SQRT(1-x**2) \n number of strips %d \n number of subintervals    :  %d \n",n, nin);

/* numerical approximation */
  width = 1./nin;
  pia = 0.; 
  t = MPI_Wtime();
  for (i = 1 ;i <=nin; i++){
       t1 = MPI_Wtime();
       hi = i * width;
       lo = hi - width;
       nl = n*(f(lo)-f(hi));
       delt = (hi-lo)/nl;
       pia = numint(lo, delt, nl, pia);
       t1 = MPI_Wtime()-t1;
       printf("domain %i with %i strips in %20.15f sec \n", i, nl, t1);
  }
  t = MPI_Wtime()-t;
  r = n/t*1.e-6;

/*  output of results*/
  printf("\n pi exact          = %20.15f",piexact);
  printf("\n pi estimated      = %20.15f",pia);
  printf("\n error exact       = %20.3e \n",fabs(pia-piexact));
  printf("\n time: %11.2e s, rate : %8.2f  [Mstrips/s] \n",t,r);
  MPI_Finalize();
  return 0;
}




