#include "mpi.h"
#include<math.h>
#include<stdlib.h>
#include<stdio.h>

void worker(int ipfa, int n, int ndom);
double farmer(int n,int ndom);

int main(int argc,char **argv)
{ 
  int np, me, ipfa=0, idle = 0;
  MPI_Status stat;
  
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&np);
  MPI_Comm_rank(MPI_COMM_WORLD,&me);     

  double piexact = 3.14159265358979323846264338327950288419, pia, r, t;
  int n, ndom;
  
  if (me == ipfa){
/*  number of strips and intervals */
     printf("\n  number of strips ?  \n");
     scanf("%d",&n);
     printf("\n  number of intervalls ?  \n");
     scanf("%d",&ndom);
     printf("\n calculation of pi using numerical integration of SQRT(1-x**2) \n number of strips %d \n number of subintervals    :  %d \n",n, ndom);
  }
  MPI_Bcast(&n,1,MPI_INT,ipfa,MPI_COMM_WORLD);
  MPI_Bcast(&ndom,1,MPI_INT,ipfa,MPI_COMM_WORLD);

// --------------------------- worker  -----------------------
  if (me != ipfa) {
     worker(ipfa,n,ndom);
     MPI_Barrier(MPI_COMM_WORLD);
  }

// --------------------------- farmer  -----------------------
   if (me == ipfa) {
      t = MPI_Wtime();
      pia = farmer(idle,ndom);
      t = MPI_Wtime() - t;
      r = n/t*1.e-6;
      MPI_Barrier(MPI_COMM_WORLD);

/*  output of results*/
         printf("\n pi exact          = %20.15f",piexact);
         printf("\n pi estimated      = %20.15f",pia);
         printf("\n error             = %20.3e\n",fabs(pia-piexact));
      printf("\n time: %11.2e s, rate : %8.2f  [Mstrips/s] \n",t,r);
    }
  MPI_Finalize();
  return 0;
}
